/*
** CClockControl.h
*/

#ifndef RATTE_CCLOCKCONTROL_H
#define RATTE_CCLOCKCONTROL_H

#include "CTime.h"
#include "Control.h"
#include "Bitmap.h"
#include "PopUpMenu.h"
#include "MenuItem.h"

class CClockControl : public BControl {
public:
	CClockControl( BPoint position, const char *name, BMessage *message, uint32 flags );
	virtual ~CClockControl();

	virtual void MessageReceived( BMessage *message );
	virtual void AttachedToWindow();
	virtual void GetPreferredSize( float *width, float *height );

	const CTime &GetTime();
	virtual void SetTime( const CTime &time );

private:
	virtual void Draw( BRect updaterect );
	virtual void MouseDown( BPoint point );
	virtual void MouseMoved( BPoint point, uint32 transit, const BMessage *message );
	virtual void MouseUp( BPoint where );

	void DrawFinger( int16 minute, float length, bool fat = false, bool second = false);
	int16 CalcMinute( const BPoint &ctr );
	void SetAmPm();

	const BBitmap *GetBitmap();
	static const BBitmap *clockbmp;
	static int32 usage_cnt;

	CTime now, backup;
	BRect dragRect;

	BPopUpMenu *menu;
	BMenuItem *amItem, *pmItem;

	bool pm, dragging, dropping;
	int16 turning;

	static int16 finger_sensitivity;

// hide the following:
	virtual void SetValue( int32 ) {};
	int32 Value() { return 0; };
};

#endif
