/* CTime.h
*/

#ifndef RATTE_CTime_LIB_H
#define RATTE_CTime_LIB_H

#include "Application.h"

/**/ // class CTime {
class CTime {
public:
	CTime();
	CTime( int32 seconds );
	CTime( int32 days, int32 hours, int32 minutes, int32 seconds );
	CTime( const CTime& time );

	int32 Day( int32 days );
	int32 Hour( int32 hours );
	int32 Minute( int32 minutes );
	int32 Second( int32 seconds );

	int32 Day() const;
	int32 Hour() const;
	int32 Minute() const;
	int32 Second() const;

	int32 AsSeconds() const;

	CTime& operator=( const CTime& time );
	CTime& operator+=( const CTime& time );
	CTime operator+( const CTime& time ) const;
	CTime& operator-=( const CTime& time );
	CTime operator-( const CTime& time ) const;

	CTime& operator*=( int32 );
	CTime operator*( int32 ) const;
	CTime& operator/=( int32 );
	CTime operator/( int32 ) const;

	int16 operator==( const CTime& time ) const;
	int16 operator!=( const CTime& time ) const;
	int16 operator>( const CTime& time ) const;
	int16 operator<( const CTime& time ) const;
	int16 operator>=( const CTime& time ) const;
	int16 operator<=( const CTime& time ) const;

private:
	int32 day, hour, minute, second;
};///

#endif
