/*
** CString.cpp
*/

#include <Application.h>
#include <stdio.h>

#include "CString.h"

CString::CString() : BString() {}
CString::CString( const BString &bs ) : BString( bs ) {}
CString::CString( const char *cp ) : BString( cp ) {}
CString::~CString() {}

CString::CString( int16 anInt16, const char *format ) : BString() {
	char buf[ 100 ];
	sprintf( buf, format, anInt16 );
	*this = buf;
}

CString::CString( int32 anInt32, const char *format ) : BString() {
	char buf[ 100 ];
	sprintf( buf, format, anInt32 );
	*this = buf;
}

CString::CString( int64 anInt64, const char *format ) : BString() {
	char buf[ 100 ];
	sprintf( buf, format, anInt64 );
	*this = buf;
}

CString::CString( float aFloat, const char *format  ) : BString() {
	char buf[ 100 ];
	sprintf( buf, format, aFloat );
	*this = buf;
}

CString &CString::Format( const char* format ) {
	*this = "";
	fpos = 0;
	from = format;

	while ( true ) {
		if ( CopyUntilToken()) break;
		if ( GetToken()) break;
		AddToken( ident );
	}
	return *this;
}

// protected:
void CString::AddToken( const BString &name ) {
	if ( name.Length() == 0 ) {	// append a "%"
		*this += '%';
	} else {		// append Errormessage
		*this += "Unknown Token: ";
		*this += '"';
		*this += name;
		*this += '"';

	}
}

// private:
bool CString::CopyUntilToken() {

	while ( true ) {
		if ( from[ fpos ] == 0 ) {
			return true;
		}
		if ( from[ fpos ] == '%' ) {
			fpos++;
			return false;
		}
		*this += from[ fpos++ ];
	}
}

bool CString::GetToken() {

	ident = "";
	while ( true ) {
		if ( from[ fpos ] == '%' ) {
			fpos++;
			return false;
		}
		if ( from[ fpos ] == 0 ) {
			return true;
		}
		ident += from[ fpos++ ];
	}
}
